﻿### CINEMA

**Cinema** - комплекс программных средств быстрой разработки сервисов, их управление и мониторинг.

Компилировать группу проектов Cinema.groupproj. Результат раскладывается на два основных каталога:

- /bin/dtl - дизайнтайм компоненты для создания сценариев обработки данных и управления ими;
- /bin/rtl - рантайм компоненты необходимые для выполнения сценариев.

Для администрирования необходимы оба каталога. Для выполнения сценариев достаточно "/bin/rtl", поэтому, 
на тех узлах где не предпологается использвание средств создания и управления сценариями каталог 
"/bin/dtl" не обязателен к портированию на ЭВМ. 

В каждом каталоге так же компоненты делятся по поткаталогам определяющим целевую ОС, т.е., например,
Linux64, Win32, Win64. Соответственно, при портировании можно исключать каталоги с не целевыми ОС.

### Текущие компоненты

- **Cinema** - ядро загрузки и исполнения сценария обработки данных; поставляется в виде библиотеки (Cinema.dll/libCinema.so);
- **Scenarist** - приложение создания и выполнения сценариев через подключённое ядро Cinema предназначено для отладки плагинов и сценариев в процессе разработки;
- **Actor**	- приложение для выполнения сценария через подключённое ядро Cinema; предназначен для запуска и выполнения сценариев приложением CinemaNode, отправки ему статистики работы по сети
- **CinemaNode** - приложение запуска, контроля работоспособности и остановки сценариев через приложение Actor;
- **Cinema Hypervisor** - приложение создания сценариев, их удалённого выполнения и мониторинга через сетевое соединение с CinemaNode;
- **набор библиотек** с плагинами различного назначения на основе которых строятся сценарии обработки данных.
	
**Scenarist** - графическое приложение, как правило, необходим для отладки плагинов и сценариев, т.е. инструмент 
который ближе к программисту. Через подключённое ядро Cinema загружает и выполняет сценарий в своём адресном 
пространстве оперативной памяти, что позволяет программисту использовать отладчик.

**Actor** не содержит GUI, получает через командную строку путь к сценарию которые необходимо выполнять. Если 
сценарий не будет найден, тогда Actor немедленно завершит свою работу. Иначе будет выполнять сценарий до тех 
пор пока не получит команду на остановку (от локального сервера к которому он пытается подключиться через сетевой 
протокол Cinema на TCP порт 23357, в настоящий момент это CinemaNode).

Комплекс приложений **"Cinema Hypervisor"<->"CinemaNode"<->"Actor"** позволяет оперативно удалённо управлять 
сценариями, масштабировать их на неограниченное количество серверов, мониторить в реальном времени состояние 
их выполнения. Предназначен для администраторов инфраструктуры. Взаимодействие выполняется через частный
двоичный протокол Cinema (см. юнит Cinema.Net.Protocol) поверх протокола TCP.

Имеющиеся плагины на текущий момент:

1. Группа **Network** - плагины для работы с сетью
1.1. **Client** - отправка данных на указанный в настройках адрес и порт.
1.2. **Server** - приём данных из сети с определённого в настройках порта.
1.3. **HTTPClient** - формирование тела HTTP-запроса.
1.4. **HTTPServer** - разбор тела HTTP-запроса.
1.5. **DataWrapper** - упаковка входного потока данных в формат частного прикладного протокола Cinema.
1.6. **DataUnwrapper** - распаковка входного потока данных из формата частного прикладного протокола Cinema.
1.7. **Snifer** - сканирование сетевого трафика.
1.7. **IPFilter** - Фильтр ip-пакетов.

2. Группа **DataBase** - плагины для работы с базами данных.
2.1. **DBReader** - чтение данных из базы.
2.2. **DBWriter** - запись данных в базу.
2.3. **DBCleaner** - удаление записей из базы.
2.4. **DBUpdater** - обновление записей в базе.

3. Группа **System** - системные дополнительные плагины обеспечивающие гибкость в построении алгоритма различных сценириев обработки данных.
3.1. **Attributes** - плагин для работы с атрибутами потока данных.
3.2. **Delay** - выполняет задержку входного потока данных на указанное время.
3.3. **DataSource** - используется как источник статических данных данных указанных в настройках.
3.4. **Copy** - размножает входной поток данных на N экземпляров.
3.5. **Terminator** - блокрует поток данных.
3.6. И т.д. и т.п.

4. Группа **Files** - плагины для работы с файловой системой. 
4.1. **PathReader** - чтение файлов. 
4.2. **FileStreams** - сохранение в файлы.
4.3. **FileMover** - перенос файлов.

5. Группа Doc - плагины предназначенные для обработки информации в различных представлениях - текст, изображения, документы, и т.п.
5.1. OCR - плагин распоснавания текста в изображениях.

