﻿#pragma once

#ifndef CINEMA_LIBRARY_EXPORTS_H
#define CINEMA_LIBRARY_EXPORTS_H

#ifndef CINEMA_LIB_EXPORT
#define CINEMA_LIB_EXPORT extern "C" __declspec(dllexport) 
#endif // #ifndef CINEMA_LIB_EXPORT extern "C" 

#ifdef _CINEMA_LIB_

#include "Cinema.Interfaces.h"


// <summary> вернуть список реализованных плагинов </summary>
CINEMA_LIB_EXPORT PPluginDescription STDMETHODCALLTYPE GetPluginsList(int* ACount);

// <summary> Создать плагин реализованный под именем AName </summary>
// <param name="AConfiguration"> Конфигурация плагина. Формат определяет разработчик плагина </param>
// <param name="ACinema"> Интерфейс отправки данных полученных в процессе работы плагина </param>
CINEMA_LIB_EXPORT bool STDMETHODCALLTYPE CreatePlugin2(WCHAR* AName, WCHAR* AConfiguration, ICinema* ACinema, void** APlugin);


#else

#endif //#ifdef _CINEMA_LIB_

#endif //#ifndef CINEMA_LIBRARY_EXPORTS_H

