﻿#include "pch.h"
#include "CinemaPluginTemplate.h"
#include "TemplateProcessor.h"

CinemaPluginTemplate::CinemaPluginTemplate(ICinema* ACinema, WCHAR* configuration)
{
	FCinema = ACinema;
	FTable = (IPluginTable*)FCinema->CreateTable((wchar_t*)L"SoundAMR", (wchar_t*)L"My test table");
	FTable->AddColumn((wchar_t*)L"Column1", (wchar_t*)L"Column 1", atString);
	FTable->AddRow();
	FTable->SetCell(0, 0, (wchar_t*)L"Column1");
}

CinemaPluginTemplate::~CinemaPluginTemplate()
{
	FCinema = NULL;
}

void* __stdcall CinemaPluginTemplate::CreateDataStreamProcessor(TDataStream AInputDataStream, int ANumberInput)
{
	// Здесь можно создать экземпляр обработчика любого типа и вернуть его в качестве результата.
	// Этот обработчик может выполнять обработку входных в методе ProcessDataStream

	FCinema->SendMessageW((wchar_t*)L"Test message", 0);
	return new TemplateProcessor(AInputDataStream);
}

void __stdcall CinemaPluginTemplate::ProcessDataStream(void* AProcessor, byte* AData, __int64 ASize)
{
	// тут необходимо передать данные AData на обработку экземпляру AProcessor
	((TemplateProcessor*)AProcessor)->Process((char*)AData, ASize);
	// результат обработки можно отправить далее на выход, например таким образом: 
	// 
	// TDataStream stream = FCinema->CreateStream(0, ((TemplateProcessor*)AProcessor)->GetInputStream());
	// FCinema->SendData(stream, someResult, someResultSize);
	// FCinema->DestroyStream(stream);
}

void __stdcall CinemaPluginTemplate::DestroyDataStreamProcessor(void* AProcessor)
{
	// освобождение экземпляра обработчика
	delete (TemplateProcessor*)AProcessor;
}

void __stdcall CinemaPluginTemplate::RedrawView()
{
}
