﻿// dllmain.cpp : Defines the entry point for the DLL application.
#include "pch.h"
#include "../../../C++/Cinema.Interfaces.h"
#include "../../../C++/Cinema.Library.h"
#include "../../../C++/Cinema.Library.Exports.h"
#include "../../../C++/Cinema.Plugin.h"
#include "../../../C++/Cinema.Plugin.cpp"
#include "Cinema.Template.Interfaces.h" 
#include "CinemaPluginTemplate.h"

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
                     )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }
    return TRUE;
}


/* обязательные для реализации в DLL функции(интерфейсные методы) */

// <summary> вернуть список реализованных плагинов </summary>
CINEMA_LIB_EXPORT PPluginDescription STDMETHODCALLTYPE GetPluginsList(int* OutCount) {
    *OutCount = PluginsCount;
    return (PPluginDescription) &CINEMA_TEMPLATE_PLUGINS[0];
};

// <summary> Создать плагин реализованный под именем AName </summary>
// <param name="AConfiguration"> Конфигурация плагина. Формат определяет разработчик плагина </param>
// <param name="ACinema"> Интерфейс отправки данных полученных в процессе работы плагина </param>
CINEMA_LIB_EXPORT bool STDMETHODCALLTYPE CreatePlugin2(wchar_t* AName, wchar_t* AConfiguration, ICinema* ACinema, void** APlugin)
{
    if (memcmp(AName, L"TemplateC", 18) == 0) {
        ICinemaPlugin* plugin = new CinemaPluginTemplate(ACinema, AConfiguration);
        *APlugin = plugin;
        return true;
    }
    
    return false;
};

