﻿unit CinemaPlugin;

interface

uses
    Cinema.Interfaces
  ;

{ обязательные для реализации в DLL функции (интерфейсные методы) }

// <summary>вернуть список реализованных плагинов</summary>
function GetPluginsList(ACount: PInteger): PPluginDescription; stdcall;

// <summary> Создать плагин реализованный под именем AName </summary>
// <param name="AConfiguration"> Конфигурация плагина. Формат определяет разработчик плагина </param>
// <param name="ACinema"> Интерфейс отправки данных полученных в процессе работы плагина </param>
function CreatePlugin(AName: PWideChar; AConfiguration: PWideChar; const ACinema: ICinema): ICinemaPlugin; stdcall;

const
  // пример описания выходных связей и данных отправляемых плагином по ним;
  // в данном случае имеет два выходных канала, в нулевой канал отправляет HTTP запросы,
  // а в 1-й FTP
  MY_PLUGIN_OUT_COUNT_CONNECTIONS = 1;
  MY_PLUGIN_OUT_NAMED_CONNECTIONS: array[0..MY_PLUGIN_OUT_COUNT_CONNECTIONS - 1] of TNamedOutputConnection =
  ((Name: 'Here I am will send HTTP data'; Number: 0));

  COUNT_PLUGINS = 1;
  PLUGINS: array[0..COUNT_PLUGINS-1] of TPluginDescription =
  ((Name: 'MyPlugin';
    Autor: '';
    Created: '23.03.2024';
    Version: '1.0';
    Description: '';
    AutorLastModified: '';
    CountNamedConnections: MY_PLUGIN_OUT_COUNT_CONNECTIONS;
    NamedOutputConnection: @MY_PLUGIN_OUT_NAMED_CONNECTIONS[0]));

implementation

uses
    Plugin
  ;

function GetPluginsList(ACount: PInteger): PPluginDescription; stdcall;
begin
  Result := @PLUGINS[0];
  ACount^ := COUNT_PLUGINS;
end;

function CreatePlugin(AName: PWideChar; AConfiguration: PWideChar; const ACinema: ICinema): ICinemaPlugin;
begin
  // выбор плагина который нужно создать; так как в данном модуле реализован только один плагин - сравниваем с его именем
  if string(PLUGINS[0].Name) = string(AName) then
    Result := TCinemaMyPlugin.Create(ACinema, AConfiguration)
  else
    Result := nil;
end;

exports
  GetPluginsList,
  CreatePlugin
  ;

end.
