﻿unit Plugin;

interface

uses
    Cinema.Interfaces
  ;

type
  TCinemaMyPlugin = class(TInterfacedObject, ICinemaPlugin)
  private
    FCinema: ICinema;
  public
    constructor Create(const ACinema: ICinema; AConfiguration: PWideChar);
    function CreateDataStreamProcessor(AInputDataStream: TDataStream; ANumberInput: Integer): Pointer; stdcall;
    procedure ProcessDataStream(AProcessor: Pointer; AData: PByte; ASize: Int64); stdcall;
    procedure DestroyDataStreamProcessor(AProcessor: Pointer); stdcall;
    procedure RedrawView; stdcall;
  end;

implementation

uses
    PluginPipeDataProcessor
  ;

{ TCinemaMyPlugin }

constructor TCinemaMyPlugin.Create(const ACinema: ICinema; AConfiguration: PWideChar);
begin
  FCinema := ACinema;
end;

function TCinemaMyPlugin.CreateDataStreamProcessor(AInputDataStream: TDataStream; ANumberInput: Integer): Pointer;
begin
  Result := TPluginPipeDataProcessor.Create(FCinema, AInputDataStream);
end;

procedure TCinemaMyPlugin.DestroyDataStreamProcessor(AProcessor: Pointer);
begin
  TPluginPipeDataProcessor(AProcessor).Free;
end;

procedure TCinemaMyPlugin.ProcessDataStream(AProcessor: Pointer; AData: PByte; ASize: Int64);
begin
  TPluginPipeDataProcessor(AProcessor).Process(AData, ASize);
end;

procedure TCinemaMyPlugin.RedrawView;
begin

end;

end.
