﻿unit PluginPipeDataProcessor;

interface

uses
    Cinema.Interfaces
  ;

type

  TPluginPipeDataProcessor = class
  private
    FInputDataStream: TDataStream;
    FCinema: ICinema;
  public
    constructor Create(const ACinema: ICinema; AInputDataStream: TDataStream);
    procedure Process(AData: PByte; ASize: Int64);
  end;

implementation

uses
    Cinema.Types
  ;

{ TPluginPipeDataProcessor }

constructor TPluginPipeDataProcessor.Create(const ACinema: ICinema; AInputDataStream: TDataStream);
begin
  FCinema := ACinema;
  FInputDataStream := AInputDataStream;
end;

procedure TPluginPipeDataProcessor.Process(AData: PByte; ASize: Int64);
begin
  // Реализовать обработку данных AData
  FCinema.SendMessage('Hello, Cinema!', MESSAGE_INFO);
end;

end.
