﻿unit Cinema.Interfaces.FuncExport;

{$ifdef FPC}
  {$mode delphi}
{$endif}

interface

uses
  SysUtils,
  Cinema.Types,
  Cinema.Interfaces,
  Cinema.Scenario.Interfaces
  ;

procedure InitCinema(const APath: string = '');

var
  LoadScenario: function(AScenario: PWideChar): ICinemaScenario; stdcall;
  LoadScenarioExt: function(AFileName: PWideChar; AEventListener: IExternalEventListener): ICinemaScenario; stdcall;
  CreateScenario: function(AFileName: PWideChar): ICinemaScenario; stdcall;
  CreateScenario2: procedure(AFileName: PWideChar; out AScen: Pointer); stdcall;
  SetAppPath: procedure(AAppPath: PWideChar); stdcall;

  // отдельная группа методов для работы без интерфейса ICinemaScenario
  //CreateScenario2: function (AFileName: PWideChar; ALenName {типа так безопаснее если знать длину строки, в символах}: int32; AEventListener: IExternalEventListener): Pointer; {$ifdef posix} cdecl; {$else} stdcall; {$endif}
  //RunScenario: function (AScenario: Pointer): Boolean; {$ifdef posix} cdecl; {$else} stdcall; {$endif}
  //StopScenario: function (AScenario: Pointer): Boolean; {$ifdef posix} cdecl; {$else} stdcall; {$endif}
  //TerminateScenario: function (AScenario: Pointer): Boolean; {$ifdef posix} cdecl; {$else} stdcall; {$endif}
  //FreeScenario: procedure (AScenario: Pointer); {$ifdef posix} cdecl; {$else} stdcall; {$endif}


implementation

uses
{$ifdef MSWINDOWS}
  Windows,
{$endif}
  Cinema.Configuration
  ;

procedure InitCinema(const APath: string = '');
var
  hCinema: {$ifdef fpc}TLibHandle {$else} THandle {$endif};
begin
  {$IF DEFINED(CPUX86) or DEFINED(CPUX64)}
  //FSetExceptMask(femINEXACT or femUNDERFLOW or femOVERFLOW or femDIVBYZERO or femINVALID);
  {$IFEND}

  if not FileExists(TCinemaConfiguration.RtlCorePath) then
    raise Exception.Create('Cinema did not initialized: library was not found!');

  hCinema := {$ifdef fpc}
    {$ifdef MSWINDOWS}
      LoadLibraryW(PWideChar(TCinemaConfiguration.RtlCorePath))
    {$else}
      LoadLibrary(TCinemaConfiguration.RtlCorePath)
    {$endif}
  {$else}
  LoadLibrary(PWideChar(TCinemaConfiguration.RtlCorePath))
  {$endif};
  if hCinema < 32 then
    raise Exception.Create('Cinema did not initialized!');
  LoadScenario := GetProcAddress(hCinema, 'LoadScenario');
  LoadScenarioExt := GetProcAddress(hCinema, 'LoadScenarioExt');
  CreateScenario := GetProcAddress(hCinema, 'CreateScenario');
  CreateScenario2 := GetProcAddress(hCinema, 'CreateScenario2');
  SetAppPath := GetProcAddress(hCinema, 'SetAppPath');


  //CreateScenario2 := GetProcAddress(hCinema, 'CreateScenario2');
  //RunScenario := GetProcAddress(hCinema, 'RunScenario');
  //StopScenario := GetProcAddress(hCinema, 'StopScenario');
  //TerminateScenario := GetProcAddress(hCinema, 'TerminateScenario');
  //FreeScenario := GetProcAddress(hCinema, 'FreeScenario');
end;

end.
