﻿unit Cinema.Configurator.View.HelpDialog;

{$ifdef FPC}
  {$mode Delphi}
{$endif}

interface

uses
    SysUtils
  , Types
  , System.UITypes
  , Classes
  , Forms
  , Controls
  , StdCtrls
  , Graphics
  , Variants
  , Buttons
  , ActnList
  , ExtCtrls

  , Cinema.Scenario.Interfaces
  , Cinema.Interfaces;

type
  TfrmConfiguratorHelpDialog = class(TForm)
    ImageList: TImageList;
    ActionList: TActionList;
    acnAccept: TAction;
    btnAccept: TButton;
    MemoJson: TMemo;
    acnEsc: TAction;
    procedure acnAcceptExecute(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure acnEscExecute(Sender: TObject);
  private
  public
    procedure ShowHelpDialog(APluginDescription: PPluginDescription);
  end;

var
  frmConfiguratorHelpDialog: TfrmConfiguratorHelpDialog;

implementation

{$ifdef FPC}
  {$R *.lfm}
{$else}
  {$R *.fmx}
{$endif}

uses
    Math
  , Cinema.Utils
  ;

{ TfrmConfiguratorHelpDialog }

procedure TfrmConfiguratorHelpDialog.acnAcceptExecute(Sender: TObject);
begin
  Close;
  ModalResult := mrOk;
end;

procedure TfrmConfiguratorHelpDialog.acnEscExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmConfiguratorHelpDialog.FormShow(Sender: TObject);
begin

  if Left < 0 then
    Left := 0;

  if Top < 0 then
    Top := 0;

end;

procedure TfrmConfiguratorHelpDialog.ShowHelpDialog(APluginDescription: PPluginDescription);
begin
  Caption := string('Описание и спецификация плагина ') + WideToString(APluginDescription.Name) + string(' ') + WideToString(APluginDescription.Version);
  MemoJson.Lines.Clear;
  MemoJson.Lines.Add(string('Автор: ') + WideToString(APluginDescription.Autor) + sLineBreak);
  MemoJson.Lines.Add(string('Дата создания: ') + WideToString(APluginDescription.Created) + sLineBreak);
  MemoJson.Lines.Add(string('Автор последних изменений: ') + WideToString(APluginDescription.AutorLastModified) + sLineBreak + sLineBreak);
  MemoJson.Lines.Add(string('Описание: ') + sLineBreak + WideToString(APluginDescription.Description) + sLineBreak + sLineBreak);
  MemoJson.Lines.Add(string('Спецификация конфигурации: ') + sLineBreak + WideToString(APluginDescription.SchemeConfig) + sLineBreak + sLineBreak);
  {$ifdef fpc}
  Left := Max(0, Mouse.CursorPos.X - Width div 2);
  Top := Max(0, Mouse.CursorPos.Y - Height div 2);
  {$else}
  Left := Max(0, Screen.MousePos.Truncate.X - Width div 2);
  Top := Max(0, Screen.MousePos.Truncate.Y - Height div 2);
  {$endif}
  ShowModal;
end;

end.
